package cpcns.dingZhi.zHUANTI.service.impl;

package .tmp;

import cpcns.baoguanqixiancelue.service.IGQuanZongWeiHuService;
import cpcns.base.common.User;
import cpcns.base.configuration.AppConfiguration;
import cpcns.dangAnBase.base.service.impl.DangAnBaseServiceImpl;
import cpcns.dingZhi.zHUANTI.dao.IZHUANTIDao;
import cpcns.dingZhi.zHUANTI.model.zHUANTI;
import cpcns.dingZhi.zHUANTI.service.IZHUANTIService;
import cpcns.utils.CommStatic;
import cpcns.utils.PagerVO;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("zHUANTIService")
public class ZHUANTIServiceImpl extends DangAnBaseServiceImpl<zHUANTI> implements IZHUANTIService {
  @Autowired
  private IZHUANTIDao zHUANTIDao;
  
  @Autowired
  private IGQuanZongWeiHuService quanZongWeiHuService;
  
  public PagerVO query_SQL(User user, Integer start, Integer rows, String table, Map<String, Object> map, String orderbysql) throws Exception {
    Map<String, Object> tp = new HashMap<>();
    String ml = (String)map.get("menLei");
    String SL = "";
    if ((StringUtils.isNotBlank(ml) && ml.contains("SWZH")) || (StringUtils.isBlank(ml) && table.toUpperCase().equals("D_ZHUANTI")))
      SL = ",(SELECT count(1) FROM D_ZHUANTISHEBIEMA s WHERE s.guanlianbiaoshi=t.hangbiaoshi) as zongShuLiang,(SELECT count(1) FROM D_ZHUANTISHEBIEMA s WHERE s.guanlianbiaoshi=t.hangbiaoshi and (s.jieyuezhuangtai is null or s.jieyuezhuangtai=0)) as shenYuShuLiang"; 
    StringBuffer sql = (new StringBuffer(" select hangBiaoShi,chengWenRiQi,YOUYUANWEN,zeRenZhe,WENHAO,quanZongHao,biaoTi,dangHao,guiDangNianDu,baoGuanQiXian,guanLianBiaoShi,fenLeiMingCheng,fenLeiHao,SHENHEZHUANGTAI,CUNFANGWEIZHI,jieYueZhuangTai,menLei,LAIWENDANWEI,guiDangLeiXing,miJi")).append(SL).append(" from ").append(table).append(" t where 1=1 and zhuangTai not in(:zhuangTai)");
    StringBuffer conSql = (new StringBuffer(" select count(1) from ")).append(table).append(" t where 1=1 and zhuangTai not in(:zhuangTai)");
    StringBuffer where = new StringBuffer();
    tp.put("zhuangTai", new String[] { "3", "4" });
    boolean fl = getInitVal("chaXunQuanXianKongZhi", "chaXunQuanXianKongZhi");
    if (fl) {
      Map<String, String> tjmap = new HashMap<>();
      String quanZongHao = (String)map.get("quanZongHao");
      String checkbox = (map.get("checkbox") == null) ? "false" : (String)map.get("checkbox");
      String all_qz = this.quanZongWeiHuService.getAllQzuanZhong(user.getQuanZongHao());
      tjmap.put("guanLianQuanZong", all_qz);
      tjmap.put("checkbox", checkbox);
      tjmap.put("quanZongHao", quanZongHao);
      tjmap.put("table", table);
      sql.append(CommStatic.IsQuanXian(user, AppConfiguration.getConfigValue("CPCNS_XITONGLEIXING"), tjmap));
    } 
    Object para = null;
    para = map.get("querystr");
    if (para != null && para != "") {
      Object menLei = map.get("menLei");
      if (menLei != null && menLei != "") {
        where.append(" and menLei =:menLei");
        tp.put("menLei", menLei);
      } 
      CommStatic.zhuHeQueryJieXi_map(where, tp, para.toString(), (String)map.get("zuHeType"), getDataType());
    } else {
      para = map.get("menLei");
      if (para != null && para != "") {
        where.append(" and menLei=:menLei");
        tp.put("menLei", para);
      } 
      para = map.get("chengWenRiQi");
      if (para != null && para != "") {
        where.append(" and chengWenRiQi=:chengWenRiQi");
        tp.put("chengWenRiQi", para);
      } 
      para = map.get("YOUYUANWEN");
      if (para != null && para != "") {
        where.append(" and YOUYUANWEN=:YOUYUANWEN");
        tp.put("YOUYUANWEN", para);
      } 
      para = map.get("zeRenZhe");
      if (para != null && para != "") {
        where.append(" and zeRenZhe=:zeRenZhe");
        tp.put("zeRenZhe", para);
      } 
      para = map.get("WENHAO");
      if (para != null && para != "") {
        where.append(" and WENHAO=:WENHAO");
        tp.put("WENHAO", para);
      } 
      para = map.get("quanZongHao");
      if (para != null && para != "") {
        where.append(" and quanZongHao=:quanZongHao");
        tp.put("quanZongHao", para);
      } 
      para = map.get("biaoTi");
      if (para != null && para != "") {
        where.append(" and biaoTi like :biaoTi");
        tp.put("biaoTi", "%" + para + "%");
      } 
      para = map.get("dangHao");
      if (para != null && para != "") {
        where.append(" and dangHao=:dangHao");
        tp.put("dangHao", para);
      } 
      para = map.get("baoGuanQiXian");
      if (para != null && para != "") {
        where.append(" and baoGuanQiXian=:baoGuanQiXian");
        tp.put("baoGuanQiXian", para);
      } 
      para = map.get("guiDangNianDu");
      if (para != null && para != "") {
        tp.put("guiDangNianDu", para);
        para = map.get("guiDangNianDu_Operator");
        if (para != null && para != "") {
          where.append(" and guiDangNianDu ").append(para).append(":guiDangNianDu");
        } else {
          where.append(" and guiDangNianDu ").append("=:guiDangNianDu");
        } 
      } 
      para = map.get("fenLeiHao");
      if (para != null && para != "") {
        where.append(" and fenLeiHao=:fenLeiHao");
        tp.put("fenLeiHao", para);
      } 
      para = map.get("SHENHEZHUANGTAI");
      if (para != null && para != "") {
        where.append(" and SHENHEZHUANGTAI=:SHENHEZHUANGTAI");
        tp.put("SHENHEZHUANGTAI", para);
      } 
      para = map.get("bianMa");
      if (para != null && para != "") {
        where.append(" and hangBiaoShi in(select guanlianbiaoshi from D_ZHUANTISHEBIEMA where bianMa=:bianMa)");
        tp.put("bianMa", para);
      } 
      para = map.get("guiDangLeiXing");
      if (para != null && para != "")
        if (para.equals("2")) {
          where.append(" and guanLianBiaoShi =0");
        } else {
          where.append(" and guanLianBiaoShi > 0");
        }  
    } 
    PagerVO pagervo = this.zHUANTIDao.queryBySql(String.valueOf(sql.toString()) + where + orderbysql, String.valueOf(conSql.toString()) + where, tp, start.intValue(), rows.intValue());
    List<Map<String, Object>> listddd = pagervo.getRows();
    setMiJiInfo(listddd);
    return pagervo;
  }
  
  public void deleteBySql(String sql) {
    this.zHUANTIDao.update(sql);
  }
  
  public void updateORSave(String sql) {
    this.zHUANTIDao.updateORSave(sql);
  }
}
